from string import Template
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
headerTemplate = Template("""\
/******************************************************************************
 *
 * clFault${scope}Cfg.c
 *
 ******************************************************************************
 * This code is auto-generated by OpenClovis IDE Version 3.1
 *
 ***************************** Description ************************************
 *
 * This file contains application specific FML
 * configuration data and callouts.
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <clEoApi.h>
#include <clFaultDefinitions.h>
#include <clFaultApi.h>
#include <clFaultErrorId.h>
#include <clDebugApi.h>
#define SIMULATION_VERSION
/**@#-*/
#ifndef COMP_DEBUG_VAR
#define COMP_DEBUG_VAR CL_DEBUG_TRACE
#endif

${externList}
ClUint32T ${probPeriodVar} = ${period};
""")


localExternListTemplate = Template("""

extern ClRcT ClFaultCompRestartRequest(ClFaultRecordPtr hRec);
extern ClRcT clFaultEscalate(ClFaultRecordPtr hRec);

""")

globalExternListTemplate = Template("""

extern ClRcT ClFaultNodeRestartRequest(ClFaultRecordPtr hRec);
""")


#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
handlerHeaderTemplate = Template("""\
/******************************************************************************
 *
 * clFault${scope}RepairHandlers.c
 *
 ******************************************************************************
 * This code is auto-generated by OpenClovis IDE  Version 3.1
 *
 *****************************************************************************/

#include <stdio.h>
#include <clEoApi.h>
#include <clFaultDefinitions.h>
#include <clFaultErrorId.h>
#include <clDebugApi.h>

/*
 * ---BEGIN_APPLICATION_CODE---
 */

/*
 * ---END_APPLICATION_CODE---
 */

""")


#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
methodExternTemplate = Template("""\

extern ClRcT ${methodName}(ClFaultRecordPtr hRec);
""")

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
methodTemplate = Template("""\

ClRcT ${methodName}(ClFaultRecordPtr hRec)
{

    /*
     * ---BEGIN_APPLICATION_CODE---
     */

    /*
     * ---END_APPLICATION_CODE---
     */

    return CL_OK;
}
""")
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
oneDSeqTableTemplate = Template("""\

ClFaultSeqTblT  ${cat}${sev}_${scope}SeqTbl[] = { ${fn1}, ${fn2}, ${fn3}, ${fn4}, ${fn5}};
""")

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
twoDSeqTableTemplate = Template("""\

ClFaultSeqTblT  *${category}_${scope}2DSeqTbls[] =
{
    ${category}CR_${scope}SeqTbl,
    ${category}MJ_${scope}SeqTbl,
    ${category}MN_${scope}SeqTbl,
    ${category}WR_${scope}SeqTbl,
    ${category}IN_${scope}SeqTbl,
    ${category}CL_${scope}SeqTbl
};
""")

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
threeDSeqTableTemplate = Template("""\

ClFaultSeqTblT  **${category}_${scope}3DSeqTbls[] =
{
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls, 
    ${category}_${scope}2DSeqTbls 
};
""")

#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
localFourDSeqTableTemplate = Template("""\

ClFaultSeqTblT  **fmSeqTbls[] =
{
    com_2DSeqTbls,
    qos_2DSeqTbls,
    proc_2DSeqTbls,
    equip_2DSeqTbls,
    env_2DSeqTbls
};
""")

globalFourDSeqTableTemplate = Template("""\

ClFaultSeqTblT  ***fmgSeqTbls[] =
{
    com_g3DSeqTbls,
    qos_g3DSeqTbls,
    proc_g3DSeqTbls,
    equip_g3DSeqTbls,
    env_g3DSeqTbls
};
""")

#----------------------------------------------------------------------------------


FaultHeaderTemplate = Template("""\
/*******************************************************************************
*
* This file is auto-generated by OpenClovis IDE version 3.1
*
* clFaultRepairHandlers.c
*
********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <clEoApi.h>
#include <clFaultRepairHandlers.h>
#include <clDebugApi.h>
#include <saAmf.h>
#include <clCorMetaStruct.h>

/*
 * ---BEGIN_APPLICATION_CODE---
 */

/*
 * ---END_APPLICATION_CODE---
 */

""")

FaultRepairTableTemplate = Template("""\

ClFaultRepairHandlerTableT gRepairHdlrList[] =
{
${faultRepairEntry}
    {0,  (ClFaultRepairHandlerT) NULL}

};
""")

FaultRepairTableEntryTemplate = Template("""\
    {${enum_class},  (ClFaultRepairHandlerT) ${classname}_RepairHandler},
""")


FaultRepairFunctionTemplate = Template("""\
${faultRepairFunctionEntry}
""")


FaultRepairFunctionEntryTemplate = Template("""\

ClRcT ${classname}_RepairHandler(ClAlarmInfoT *pAlarmInfo, SaAmfRecommendedRecoveryT recoveryAction)
{

    /*
     * ---BEGIN_APPLICATION_CODE---
     */

    /*
     * ---END_APPLICATION_CODE---
     */

    return CL_OK;
}

""")
